/*
 * This file is part of roccat-tools.
 *
 * roccat-tools is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * roccat-tools is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with roccat-tools. If not, see <http://www.gnu.org/licenses/>.
 */

#include "kova2016_internal_timer.h"
#include <string.h>

void kova2016_internal_timer_set_name(Kova2016InternalTimer *timer, gchar const *new_name) {
	g_strlcpy((gchar *)(timer->name), new_name, KOVA2016_INTERNAL_TIMER_NAME_LENGTH);
}

void roccat_timer_to_kova2016_internal_timer(RoccatTimer const *roccat_timer, Kova2016InternalTimer *kova2016_timer) {
	memset(kova2016_timer, 0, sizeof(Kova2016InternalTimer));
	kova2016_internal_timer_set_name(kova2016_timer, roccat_timer->name);
	kova2016_timer->duration = roccat_timer_get_seconds(roccat_timer);
	// TODO error handling;
}

gboolean kova2016_internal_timer_equal(Kova2016InternalTimer const *left, Kova2016InternalTimer const *right) {
	return memcmp(left, right, sizeof(Kova2016InternalTimer)) ? FALSE : TRUE;
}

void kova2016_internal_timer_copy(Kova2016InternalTimer *destination, Kova2016InternalTimer const *source) {
	memcpy(destination, source, sizeof(Kova2016InternalTimer));
}

Kova2016InternalTimer *kova2016_internal_timer_dup(Kova2016InternalTimer const *source) {
	return (Kova2016InternalTimer *)g_memdup(source, sizeof(Kova2016InternalTimer));
}
