#ifndef __ROCCAT_KOVA2016_PROFILE_DATA_EVENTHANDLER_H__
#define __ROCCAT_KOVA2016_PROFILE_DATA_EVENTHANDLER_H__

/*
 * This file is part of roccat-tools.
 *
 * roccat-tools is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * roccat-tools is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with roccat-tools. If not, see <http://www.gnu.org/licenses/>.
 */

#include "kova2016_internal_timer.h"
#include "kova2016.h"
#include "roccat_swarm.h"

G_BEGIN_DECLS

typedef struct _Kova2016ProfileDataEventhandler Kova2016ProfileDataEventhandler;

enum {
	KOVA2016_PROFILE_NAME_LENGTH = 35,
	KOVA2016_OPENER_LENGTH = 256,
};

struct _Kova2016ProfileDataEventhandler {
	gboolean modified;
	gchar profile_name[KOVA2016_PROFILE_NAME_LENGTH];
	guint8 timer_notification_type;
	guint8 profile_notification_type;
	guint8 cpi_notification_type;
	gdouble notification_volume;

	gchar gamefile_names[ROCCAT_SWARM_RMP_GAMEFILE_NUM][ROCCAT_SWARM_RMP_GAMEFILE_LENGTH];
	Kova2016InternalTimer timers[KOVA2016_PROFILE_BUTTON_NUM];
	gchar openers[KOVA2016_PROFILE_BUTTON_NUM][KOVA2016_OPENER_LENGTH];
};

gboolean kova2016_profile_data_eventhandler_get_modified(Kova2016ProfileDataEventhandler const *profile_data);
void kova2016_profile_data_eventhandler_set_modified(Kova2016ProfileDataEventhandler *profile_data);
void kova2016_profile_data_eventhandler_set_unmodified(Kova2016ProfileDataEventhandler *profile_data);

void kova2016_profile_data_eventhandler_set_profile_name(Kova2016ProfileDataEventhandler *profile_data, gchar const *new_name);
void kova2016_profile_data_eventhandler_set_gamefile_name(Kova2016ProfileDataEventhandler *profile_data, guint index, gchar const *new_name);
void kova2016_profile_data_eventhandler_set_timer(Kova2016ProfileDataEventhandler *profile_data, guint index, Kova2016InternalTimer const *timer);
void kova2016_profile_data_eventhandler_set_opener(Kova2016ProfileDataEventhandler *profile_data, guint index, gchar const *new_opener);

void kova2016_profile_data_eventhandler_update_with_default(Kova2016ProfileDataEventhandler *profile_data);
gboolean kova2016_profile_data_eventhandler_update(Kova2016ProfileDataEventhandler *profile_data, guint profile_index, GError **error);

gboolean kova2016_profile_data_eventhandler_save(Kova2016ProfileDataEventhandler *profile_data, guint profile_index, GError **error);

G_END_DECLS

#endif
