/*
 * This file is part of roccat-tools.
 *
 * roccat-tools is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * roccat-tools is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with roccat-tools. If not, see <http://www.gnu.org/licenses/>.
 */

#include "roccat_swarm_color_selection_button.h"
#include "i18n-lib.h"

enum {
	ROCCAT_SWARM_COLORS_NUM = 30,
	ROCCAT_SWARM_COLORS_PER_ROW = 10,
};

static GdkColor const colors[ROCCAT_SWARM_COLORS_NUM] = {
	{0, 179 * 256,   0 * 256,   0 * 256},
	{0, 255 * 256,   0 * 256,   0 * 256},
	{0, 255 * 256,  41 * 256,   0 * 256},
	{0, 254 * 256,  99 * 256,   0 * 256},
	{0, 252 * 256, 160 * 256,   0 * 256},
	{0, 235 * 256, 254 * 256,   0 * 256},
	{0, 230 * 256, 255 * 256,   0 * 256},
	{0, 178 * 256, 255 * 256,   0 * 256},
	{0, 135 * 256, 255 * 256,   0 * 256},
	{0,  88 * 256, 255 * 256,   0 * 256},
	{0,   0 * 256, 255 * 256,   0 * 256},
	{0,   0 * 256, 231 * 256,   0 * 256},
	{0,   0 * 256, 185 * 256,   0 * 256},
	{0,   0 * 256, 226 * 256, 116 * 256},
	{0,   0 * 256, 221 * 256, 155 * 256},
	{0,   0 * 256, 207 * 256, 211 * 256},
	{0,  77 * 256, 184 * 256, 255 * 256},
	{0,  78 * 256, 142 * 256, 243 * 256},
	{0, 120 * 256, 131 * 256, 249 * 256},
	{0,  86 * 256,  91 * 256, 244 * 256},
	{0,  98 * 256,   0 * 256, 255 * 256},
	{0, 103 * 256,   0 * 256, 255 * 256},
	{0,  76 * 256,   0 * 256, 198 * 256},
	{0, 132 * 256,   0 * 256, 255 * 256},
	{0, 153 * 256,   0 * 256, 255 * 256},
	{0, 185 * 256,   0 * 256, 255 * 256},
	{0, 185 * 256,   0 * 256, 241 * 256},
	{0, 196 * 256,   0 * 256, 225 * 256},
	{0, 218 * 256,   0 * 256, 225 * 256},
	{0, 221 * 256,   0 * 256, 121 * 256},
};

G_DEFINE_TYPE(RoccatSwarmColorSelectionButton, roccat_swarm_color_selection_button, ROCCAT_COLOR_SELECTION_BUTTON_TYPE);

GtkWidget *roccat_swarm_color_selection_button_new(void) {
	return GTK_WIDGET(g_object_new(ROCCAT_SWARM_COLOR_SELECTION_BUTTON_TYPE, NULL));
}

static void roccat_swarm_color_selection_button_init(RoccatSwarmColorSelectionButton *button) {
	roccat_color_selection_button_set_view_type(ROCCAT_COLOR_SELECTION_BUTTON(button), ROCCAT_COLOR_SELECTION_DIALOG_TYPE_BOTH);
	roccat_color_selection_button_set_palette_colors(ROCCAT_COLOR_SELECTION_BUTTON(button), colors, ROCCAT_SWARM_COLORS_NUM, ROCCAT_SWARM_COLORS_PER_ROW);
}

static void roccat_swarm_color_selection_button_class_init(RoccatSwarmColorSelectionButtonClass *klass) {
}
